functor
export
   Satisfiable SatisfiableNative
import
   Native(satisfiable:SatisfiableNative) at 'mehlhorn.so{native}'
define
   proc {GoodNodes N Nodes}
      case Nodes
      of nil then skip
      [] H|T then
	 case H of I#K andthen I>=0 andthen I<N andthen
	    (K==0 orelse K==1 orelse K==3)
	 then
	    {GoodNodes N T}
	 else
	    {Exception.raiseError mehlhorn(badnode H)}
	 end
      else
	 {Exception.raiseError mehlhorn(badnodelist Nodes)}
      end
   end
   %%
   proc {GoodEdges N Edges}
      case Edges
      of nil then skip
      [] H|T then
	 case H of I#J#B
	    andthen I>=0 andthen I<N
	    andthen J>=0 andthen J<N
	    andthen (B==true orelse B==false)
	 then
	    {GoodEdges N T}
	 else
	    {Exception.raiseError mehlhorn(badedge H)}
	 end
      else
	 {Exception.raiseError mehlhorn(badedgelist Edges)}
      end
   end
   %%
   fun {Satisfiable N Nodes Edges}
      if {IsInt N} andthen N>0 then skip else
	 {Exception.raiseError mehlhorn(n:N)}
      end
      {GoodNodes N Nodes}
      {GoodEdges N Edges}
      {SatisfiableNative N Nodes Edges}
   end
end
